module ElementInspire
  def self.included(base)
    base.extend(ClassMethods)
    base.__send__ :include, InstanceMethods
  end
  
  module ClassMethods
    def panelize elements_attributes
      elements_attributes = [elements_attributes] unless elements_attributes.is_a?(Array)
      hash = {}
      index = 0
      elements_attributes.each do |element_attributes|
        hash[self.to_s.tableize + '_attributes'] ||= {}
        n = if element_attributes['id']
          element_attributes['id'].to_s
        else
          index += 1
          'new' + index.to_s 
        end
        hash[self.to_s.tableize + '_attributes'][n] = element_attributes
      end
      hash
    end
  end
  
  module InstanceMethods
    private
    
    public
    
    def parts
      @parts ||= []
    end
    
    def copy_attributes
      r = self.attributes
      r.delete 'id'
      r.delete 'panel_id'
      r.delete 'created_at'
      r.delete 'updated_at'
      self.parts.each do |part|
        new_part_attr = part ? part.class.panelize(part.copy_attributes) : {}
        r.merge! new_part_attr
      end
      r
    end
    
    def copy to_panel
      new_element = self.class.new self.copy_attributes
      new_element.t = to_panel.new_t
      new_element.z = to_panel.new_z
      new_attr = new_element.class.panelize new_element.copy_attributes
      r = {} #Panel.panelize to_panel
      r.merge! new_attr
      r
    end
    
    def copy_all index
      new_element = self.class.new self.copy_attributes
      new_attr = new_element.class.panelize(new_element.copy_attributes, index)
      r = {} #Panel.panelize to_panel
      r.merge! new_attr
      r
    end
    
  end
  
end

