#サポートツール
require 'rubygems'
require 'fileutils'
require 'json'

if ARGV.size < 1
  puts "preup.rb dirname {license.json}"
  exit
end

dirname = File.expand_path ARGV[0]
ls = if ARGV.size > 1 and File.exist?(ARGV[1]) 
  ARGV[1]
else
  nil
end

Dir.glob(dirname + '/*') do |fn|
  ext = File.extname(fn).downcase
  bn = File.basename(fn, ".*")
  s = bn.split('@')
  if s.size > 1
    caption = s[1]
    bn = s[0]
  end
  case ext
  when '.png', '.gif', '.jpeg'
    puts fn
    d = File.dirname(fn) + '/' + bn
    Dir.mkdir(d) unless File.exist?(d)
    FileUtils.cp fn, d + '/' + File.basename(fn)
    if ls
      puts 'with license:' + ls
      lsfn = d + '/' + File.basename(ls)
      if caption
        puts 'caption:' + caption
        json = JSON.parse(open(ls).read)
        if json['attributes'] and json['attributes']['caption']
          json['attributes']['caption'] = caption
        end
        File.open(lsfn, 'w') do |f|
          f.write json.to_json.to_s
        end
      else
        FileUtils.cp ls, lsfn
      end
    end
  end
end

